<template lang="pug">
  section.result
    .wrapper
      .result__description
        h2.description__title <span class="description__title--outline">Export to</span> JPEG and PSD
        p.description__description <span class="description__text">JPEGs are</span> <a href="https://icons8.com/license" class="description__link" target="_blank">free for a link</a><span class="description__text">. PSDs are</span> <a href="https://icons8.com/paid-license-99" class="description__link" target="_blank">$20/month</a><span class="description__text">, which gives you all models and objects masked and layered.</span>
      .result__circles(v-waypoint="{active: true, callback: onWaypoint}")
        div.circles__circle#circle-1
        div.circles__circle#circle-2
        img.circles__image#circle-3(src="../../static/vue-static/circleImage.png")
      .result__formats
        .formats__item
          .item__image
            img(src="../../static/vue-static/result.png")
          .item__description
            span.description__title For newsletters
            p.description__size JPEG, 1200&times;800
        .formats__item
          .item__image
            img(src="../../static/vue-static/result.png")
          .item__description
            span.description__title For blog posts
            p.description__size JPEG, 2400&times;1600
        .formats__item
          .item__image
            img(src="../../static/vue-static/result.png")
          .item__description
            span.description__title For print
            p.description__size JPEG, 3600&times;2400
        .formats__item
          .item__image
            span.image__tag PSD
            img(src="../../static/vue-static/result.png")
          .item__description
            span.description__title For polish things
            p.description__size PSD, 3600&times;2400
      a.result__button(href="/creator/dashboard")
        span.button__label Less words. I want to start
        .button__icon(v-html="$icons.buttonArrow")
</template>

<script>
import { TimelineLite } from "gsap";

export default {
  methods: {
    onWaypoint: function({ going, direction }) {
      if (
        going === this.$waypointMap.GOING_IN &&
        direction === this.$waypointMap.DIRECTION_TOP
      ) {
        this.animateCircles();
        this.animateImages();
      }
    },
    animateCircles: function() {
      const timeline = new TimelineLite();
      const elements = ["#circle-1", "#circle-2", "#circle-3"];

      timeline.staggerFromTo(
        elements,
        0.3,
        {
          scale: 0,
          opacity: 0,
          ease: Back.easeOut
        },
        {
          scale: 1,
          opacity: 1,
          ease: Back.easeOut
        },
        0.1,
        "+=0"
      );
    },
    animateImages: function() {
      const timeline = new TimelineLite();
      const elements = ".formats__item";

      timeline.staggerFromTo(
        elements,
        0.3,
        {
          scale: 0,
          opacity: 1,
          ease: Back.easeOut
        },
        {
          scale: 1,
          opacity: 1,
          ease: Back.easeOut
        },
        0.1,
        "+=0.2"
      );
    }
  }
};
</script>

<style lang="scss" scoped>
.result {
  text-align: center;
  width: 100%;
  height: 100%;
  margin: 16px 0 40px;
  color: #fff;

  @media (min-width: 576px) {
    margin: 56px 0 100px;
  }

  &__description {
    display: flex;
    flex-direction: column;
    align-items: center;
    font-weight: 400;
    text-align: center;
    margin-bottom: 32px;

    & .description {
      &__title {
        font-weight: 600;
        font-size: 32px;
        letter-spacing: -1px;
        text-transform: uppercase;
        margin-bottom: 24px;

        @media (min-width: 576px) {
          font-size: 40px;
          letter-spacing: -0.03em;
        }

        &--outline {
          color: rgba(255, 255, 255, 0);
          -webkit-text-stroke-width: 1px;
          -webkit-text-stroke-color: #fff;
        }
      }

      &__description {
        width: 100%;
        margin: 0 auto;
        font-size: 15px;
        line-height: 22px;
        margin-bottom: 64px;

        @media (min-width: 576px) {
          width: 60%;
        }
      }

      &__text {
        opacity: 0.5;
      }

      &__link {
        color: #fff;
        text-decoration: none;
      }
    }
  }

  &__circles {
    position: relative;
    margin: 0 auto 88px;
    width: 48px;
    height: 48px;

    & .circles {
      &__circle {
        display: block;
        position: absolute;
        top: -23px;
        left: -23px;
        width: 92px;
        height: 92px;
        background: rgba(#fff, 0.03);
        border-radius: 100%;
        opacity: 0;
        z-index: -1;

        &:nth-child(2) {
          width: 140px;
          height: 140px;
          top: -47px;
          left: -47px;
        }
      }

      &__image {
        position: relative;
        width: 100%;
        opacity: 0;
        z-index: 2;
      }
    }
  }

  &__formats {
    display: flex;
    flex-direction: column;
    align-items: center;
    width: 100%;
    margin: 0 auto 32px;

    @media (min-width: 1024px) {
      flex-direction: row;
      justify-content: space-between;
      align-items: auto;
      width: 70%;
      margin: 0 auto 72px;
    }

    & .formats {
      &__item {
        display: flex;
        width: calc(1060px / 8);
        margin-bottom: 32px;
        flex-direction: column-reverse;
        justify-content: space-between;
        align-items: center;
        text-align: center;

        @media (min-width: 1024px) {
          margin-bottom: 0;
          flex-direction: column;
        }

        & .item {
          &__image {
            position: relative;
            display: flex;
            height: 100%;
            align-items: center;

            & img {
              width: 100%;
            }

            & .image {
              &__tag {
                position: absolute;
                top: 8px;
                left: 8px;
                display: inline-block;
                padding: 2px 8px 3px;
                background: #0ca940;
                font-size: 10px;
                font-weight: 500;
                line-height: 12px;
                border-radius: 16px;
              }
            }
          }

          &__description {
            font-size: 15px;
            line-height: 22px;
            margin-bottom: 16px;

            @media (min-width: 1024px) {
              margin-top: 24px;
              margin-bottom: 0;
            }

            & .description {
              &__title {
                font-weight: 500;
              }

              &__size {
                margin: 0;
                opacity: 0.5;
                margin-top: 4px;
              }
            }
          }
        }

        &:nth-child(1) {
          & .item {
            &__image {
              width: 80px;
            }
          }
        }

        &:nth-child(2) {
          & .item {
            &__image {
              width: 108px;
            }
          }
        }

        &:nth-child(3) {
          & .item {
            &__image {
              width: 150px;
            }
          }
        }

        &:nth-child(4) {
          & .item {
            &__image {
              width: 150px;
            }
          }
        }
      }
    }
  }

  &__button {
    position: relative;
    width: 100%;
    box-sizing: border-box;
    padding: 16px 36px;
    background: #fff;
    font-size: 15px;
    font-weight: 500;
    color: #1a1a1a;
    border-radius: 32px;
    text-decoration: none;
    transition: 0.2s;

    @media (min-width: 1024px) {
      width: auto;
      margin-right: 24px;
    }

    &:hover {
      background: #28b351;
      color: #fff;

      .button__icon {
        fill: #fff;
      }
    }

    & .button {
      &__label {
      }

      &__icon {
        display: inline-block;
        position: relative;
        top: 5px;
        width: 14px;
        height: 20px;
        margin-left: 8px;
        fill: #1a1a1a;
      }
    }
  }
}

.wrapper {
  position: relative;
  margin: 0 auto;
  padding: 32px 0;
  max-width: 1040px;

  @media (max-width: 1024px) {
    flex-direction: column;
    padding: 8px 16px;
  }
}
</style>
